> ## Documentation Index
> Fetch the complete documentation index at: https://docs.meteroid.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Create a product



## OpenAPI

````yaml https://api.meteroid.com/api-docs/openapi.json post /api/v1/products
openapi: 3.1.0
info:
  title: meteroid
  description: ''
  license:
    name: LicenseRef-Proprietary
    identifier: LicenseRef-Proprietary
  version: 0.1.0
servers: []
security: []
tags:
  - name: Meteroid
    description: Meteroid API
  - name: Add-ons
  - name: Batch Jobs
  - name: Checkout Sessions
  - name: Connect
    description: Manage connected accounts (Express & Standard)
  - name: Coupons
  - name: Credit Notes
  - name: Customers
  - name: Entitlements
  - name: Events
  - name: Features
  - name: Invoices
  - name: Metrics
  - name: OAuth
    description: OAuth 2.0 token endpoints (public, client-credentials auth)
  - name: OAuth Apps
    description: Manage OAuth applications for Connect integrations
  - name: Plans
  - name: Product Families
  - name: Products
  - name: Subscriptions
  - name: Usage
paths:
  /api/v1/products:
    post:
      tags:
        - Products
      summary: Create a product
      operationId: create_product
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/CreateProductRequest'
        required: true
      responses:
        '201':
          description: Product created
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Product'
        '400':
          description: Bad request
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/RestErrorResponse'
        '401':
          description: Unauthorized
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/RestErrorResponse'
        '429':
          description: Too many requests
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/RestErrorResponse'
      security:
        - bearer_auth: []
components:
  schemas:
    CreateProductRequest:
      type: object
      required:
        - name
        - product_family_id
        - fee_structure
      properties:
        catalog:
          type: boolean
        description:
          type:
            - string
            - 'null'
        fee_structure:
          $ref: '#/components/schemas/ProductFeeStructure'
        name:
          type: string
        product_family_id:
          $ref: '#/components/schemas/ProductFamilyId'
    Product:
      type: object
      required:
        - id
        - name
        - fee_type
        - fee_structure
        - product_family_id
        - catalog
        - created_at
      properties:
        archived_at:
          type:
            - string
            - 'null'
          format: date-time
        catalog:
          type: boolean
        created_at:
          type: string
          format: date-time
        description:
          type:
            - string
            - 'null'
        fee_structure:
          $ref: '#/components/schemas/ProductFeeStructure'
        fee_type:
          $ref: '#/components/schemas/ProductFeeTypeEnum'
        id:
          $ref: '#/components/schemas/ProductId'
        name:
          type: string
        product_family_id:
          $ref: '#/components/schemas/ProductFamilyId'
    RestErrorResponse:
      type: object
      required:
        - code
        - message
      properties:
        code:
          $ref: '#/components/schemas/ErrorCode'
        message:
          type: string
    ProductFeeStructure:
      oneOf:
        - $ref: '#/components/schemas/RateFeeStructure'
        - $ref: '#/components/schemas/SlotFeeStructure'
        - $ref: '#/components/schemas/CapacityFeeStructure'
        - $ref: '#/components/schemas/UsageFeeStructure'
        - $ref: '#/components/schemas/ExtraRecurringFeeStructure'
        - $ref: '#/components/schemas/OneTimeFeeStructure'
      discriminator:
        propertyName: type
        mapping:
          CAPACITY:
            $ref: '#/components/schemas/CapacityFeeStructure'
          EXTRA_RECURRING:
            $ref: '#/components/schemas/ExtraRecurringFeeStructure'
          ONE_TIME:
            $ref: '#/components/schemas/OneTimeFeeStructure'
          RATE:
            $ref: '#/components/schemas/RateFeeStructure'
          SLOT:
            $ref: '#/components/schemas/SlotFeeStructure'
          USAGE:
            $ref: '#/components/schemas/UsageFeeStructure'
    ProductFamilyId:
      type: string
      format: MeteroidId
      examples:
        - pf_7n42DGM5Tflk9n8mt7Fhc7
    ProductFeeTypeEnum:
      type: string
      enum:
        - RATE
        - SLOT
        - CAPACITY
        - USAGE
        - EXTRA_RECURRING
        - ONE_TIME
    ProductId:
      type: string
      format: MeteroidId
      examples:
        - prd_7n42DGM5Tflk9n8mt7Fhc7
    ErrorCode:
      type: string
      enum:
        - BAD_REQUEST
        - NOT_FOUND
        - CONFLICT
        - FORBIDDEN
        - UNAUTHORIZED
        - TOO_MANY_REQUESTS
        - INTERNAL_SERVER_ERROR
    RateFeeStructure:
      type: object
    SlotFeeStructure:
      type: object
      required:
        - slot_unit_name
        - upgrade_policy
        - downgrade_policy
      properties:
        downgrade_policy:
          $ref: '#/components/schemas/SlotDowngradePolicyEnum'
        slot_unit_name:
          type: string
        upgrade_policy:
          $ref: '#/components/schemas/SlotUpgradePolicyEnum'
    CapacityFeeStructure:
      type: object
      required:
        - metric_id
      properties:
        metric_id:
          $ref: '#/components/schemas/BillableMetricId'
    UsageFeeStructure:
      type: object
      required:
        - metric_id
        - model
      properties:
        metric_id:
          $ref: '#/components/schemas/BillableMetricId'
        model:
          $ref: '#/components/schemas/UsageModelEnum'
    ExtraRecurringFeeStructure:
      type: object
      required:
        - billing_type
      properties:
        billing_type:
          $ref: '#/components/schemas/ExtraRecurringBillingTypeEnum'
    OneTimeFeeStructure:
      type: object
    SlotDowngradePolicyEnum:
      type: string
      enum:
        - REMOVE_AT_END_OF_PERIOD
    SlotUpgradePolicyEnum:
      type: string
      enum:
        - PRORATED
    BillableMetricId:
      type: string
      format: MeteroidId
      examples:
        - bm_7n42DGM5Tflk9n8mt7Fhc7
    UsageModelEnum:
      type: string
      enum:
        - PER_UNIT
        - TIERED
        - VOLUME
        - PACKAGE
        - MATRIX
    ExtraRecurringBillingTypeEnum:
      type: string
      enum:
        - ADVANCE
        - ARREARS
  securitySchemes:
    bearer_auth:
      type: http
      scheme: bearer

````